/*
 * Created on Dec 6, 2006
 * Created by reisdorf1
 */
package gov.llnl.ics.pe.mapguide.query;

import java.util.List;

import org.osgeo.mapguide.MgException;
import org.osgeo.mapguide.MgPoint;

/**
 * Represents a Feature, with the DisplayValue as a String representation of the Feature value,
 * along with the Features Center X,Y points.
 * 
 * @author reisdorf1
 * 
 */
public class Feature {

    private String displayValue = "";

    public double centerX;

    public double centerY;

    public List idList;

    public Feature(String displayValue, MgPoint centerPoint, List idList) throws MgException {
        super();
        this.displayValue = displayValue;
        this.centerX = centerPoint.GetCoordinate().GetX();
        this.centerY = centerPoint.GetCoordinate().GetY();
        this.idList = idList;
    }

    public double getCenterX() {
        return centerX;
    }

    public void setCenterX(double centerX) {
        this.centerX = centerX;
    }

    public double getCenterY() {
        return centerY;
    }

    public void setCenterY(double centerY) {
        this.centerY = centerY;
    }

    public String getDisplayValue() {
        return displayValue;
    }

    public void setDisplayValue(String displayValue) {
        this.displayValue = displayValue;
    }

    public List getIdList() {
        return idList;
    }

    public void setIdList(List idList) {
        this.idList = idList;
    }

    /**
     * Constructs a <code>String</code> with all attributes
     * in name = value format.
     *
     * @return a <code>String</code> representation 
     * of this object.
     */
    public String toString()
    {
        final String TAB = "    ";
        
        String retValue = "";
        
        retValue = "Feature ( "
            + super.toString() + TAB
            + "displayValue = " + this.displayValue + TAB
            + "centerX = " + this.centerX + TAB
            + "centerY = " + this.centerY + TAB
            + "idList = " + this.idList + TAB
            + " )";
        
        return retValue;
    }

}
