/*
 * Created on Dec 7, 2006
 * Created by reisdorf1
 */
package gov.llnl.ics.pe.mapguide.query;

/**
 * Represents a FeatureId for a given Object. The value is stored as a String, along with the proper
 * MgPropertyType value. When analyzing the FeatureId, one can then convert the value to the proper
 * MgProperty object using the type.
 * 
 * @author reisdorf1
 * 
 */
public class FeatureId {
    private String name;

    private int type;

    private String value;

    public FeatureId() {
        super();
    }

    public FeatureId(String name, int type, String value) {
        super();
        this.name = name;
        this.type = type;
        this.value = value;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getType() {
        return type;
    }

    public void setType(int type) {
        this.type = type;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    /**
     * Constructs a <code>String</code> with all attributes in name = value format.
     * 
     * @return a <code>String</code> representation of this object.
     */
    public String toString() {
        final String TAB = "    ";

        String retValue = "";

        retValue = "FeatureId ( " + super.toString() + TAB + "name = " + this.name + TAB + "type = " + this.type + TAB
                + "value = " + this.value + TAB + " )";

        return retValue;
    }

}
